// « Vous qui entrez ici, abandonnez toute espérance »

console.log("starting cytoscape");

document.addEventListener("DOMContentLoaded", function() {
	var incrementLink = 0;
	
	// fonction d'incrémentation d'id unique, ne jamais utiliser la variable incrementLink toute seule, toujours utiliser cette fonction.
	function incrementLinkPlus() {
		incrementLink = ++incrementLink;
		return incrementLink.toString();
	}
	
	// pamette de nuance de rouge sombres
	let paletteRustyBlue = [
		'#46201a',
		'#46201a',
		'#b95335',
		'#a4371f',
		'#1e1f26',
		'#283655',
		'#4d648d',
		'#d0e1f9',
	]
	
	// fonction pour retourner une couleur random, ne jamais utiliser paletteRustyBlue tout seule
	function chooseColor() {
		return paletteRustyBlue[Math.floor(Math.random()*paletteRustyBlue.length)];
	}
	
	// fonction de mise en place de couleur pour les liens
	function chooseColorEdge(edge) {
		if(edge.data('typeRoute') != undefined) {
			return edge.data('typeRouteColor');
		}else {
			return '#9b9b9b';
		}
	}
	
	// note : mettre des string 'id' tout petits, sinon on s'en sort pas à l'affichage.
	// Si on a vraiment besoin de plus de text, mettre un box ailleurs pour l'affichage du texte.
	let clientsData = [ 
		{ 
		  data: { id: 'Mike', type: 'desktop' }, // Mike est l'utilisateur lambda.
		},
		{ 
		  data: { id: 'Kevin', type: 'desktop' }, // Kevin est un hacker trop D4rk.
		},
		{ 
		  data: { id: 'Grace', type: 'desktop' }, // Che Guevara veux échapper à la censure.
		},
		{ 
		  data: { id: 'John', type: 'desktop'}, // L'agent Ron est du FBI, il enquête.
		}
	];
	
	// generate guardnode
	function geneguardtor(nbnode) {
		let torguardnodeData = [];
		for(nbnode; 0 < nbnode; nbnode--) {
			torguardnodeData.push({
				data: {
					id : ("friend " +  nbnode.toString()),
					type : "guard node",
					group : 'tor network',
				}
			});
		}
		return torguardnodeData;
	}
		
	// generate pure node
	function genenodetor(nbnode) {
		let tornodeData = [];
		for(nbnode; 0 < nbnode; nbnode--) {
			tornodeData.push({
				data: {
					id : ("family  " +  nbnode.toString()),
					type : "tor node",
					group : 'tor network',
				}
			});
		}
		return tornodeData;
	}
	
	// generate exit node
	function geneexittor(nbnode) {
		let torexitData = [];
		for(nbnode; 0 < nbnode; nbnode--) {
			torexitData.push({
				data: {
					id : ("suspect  " +  nbnode.toString()),
					type : "exit node",
					group : 'tor network',
				}
			});
		}
		return torexitData;
	}
	
	// génère des routes aléatoires pour le réseau
	function generateRouteTor(guard, node, exit) {
		let linkData = [];
		let listTotalNodes = guard.concat(node).concat(exit);
		listTotalNodes.forEach(function(item, index) {
			// on choisit un noeud au pif
			let indexNode = Math.floor(Math.random() * listTotalNodes.length);
			// On s'assure que c'est pas le noeud courant pour éviter une boucle
			while(indexNode == index) {
				indexNode = Math.floor(Math.random() * listTotalNodes.length);
			}
			let randNode = listTotalNodes[indexNode];
			linkData.push({
				data : {
					id : ('link ' + item.data.id + " " + randNode.data.id + " " + incrementLinkPlus()),
					source : item.data.id,
					target : randNode.data.id
				}
			});
		});
		return linkData;
	}
	
	// génère des routes spécifiques pour les clients
	function generateClientRouteTor(client, guard, node, exit) {
		// on choisit une couleur :
		let colorEdge = chooseColor();
		// on crée la liste de liens à retourner
		let linkData = [];
		// on choisit un guard
		let guardselected = guard[Math.floor(Math.random() * guard.length)];
		// on crée la route entre le client et le guard
		linkData.push({
			data : {
				id : ('link ' + client.data.id + " " + guardselected.data.id + " " + incrementLinkPlus()),
				source : client.data.id,
				target : guardselected.data.id,
				typeRoute : 'clientRoute',
				typeRouteColor : colorEdge,
			}
		});
		// on sélectionne un noeud du réseau
		let nodeselected = node[Math.floor(Math.random() * node.length)];
		// on crée la route entre le guard et un noeud du réseau
		linkData.push({
			data : {
				id : ('link ' + guardselected.data.id + " " + nodeselected.data.id + " " + incrementLinkPlus()),
				source : guardselected.data.id,
				target : nodeselected.data.id,
				typeRoute : 'clientRoute', 
				typeRouteColor : colorEdge,
			}
		});
		// on sélectionne un exit node (pour le moment, à élargir) (wtf ? a élargir ?)
		let exitselected = exit[Math.floor(Math.random() * exit.length)];
		// on crée la route entre le node et l'exit
		linkData.push({
			data : {
				id : ('link ' + nodeselected.data.id + " " + exitselected.data.id + " " + incrementLinkPlus()),
				source : nodeselected.data.id,
				target : exitselected.data.id,
				typeRoute : 'clientRoute', 
				typeRouteColor : colorEdge,
			}
		});
		// on termine et on renvoie la route créée
		return linkData;
		
	}
		
	// generate tor network
	function generateTorNetwork(clientsTor, nbguard, nbnode, nbexit) {
		let gn =  geneguardtor(nbguard);
		let n = genenodetor(nbnode);
		let en = geneexittor(nbexit);
		let c = clientsTor;
		// on crée des routes aléatoires
		let torRoute = generateRouteTor(gn, n, en);
		
		// on crée les routes des clients
		//console.log(clientsTor);
		let torRouteClient = clientsTor.map(function(elem) {
			return generateClientRouteTor(elem, gn, n, en);
		}).flat(); // flat permet de fusionner les tableau de tableau en un gros tableau de data
		return [gn.concat(n).concat(en).concat(c), torRoute.concat(torRouteClient)];
	}
	
	// fonction de génération du graph globale
	function createCyto() {
		// création objet canvas cytoscape
		let cret = cytoscape({
		  container: document.getElementById('cytocontainer'),
			elements: [],
			style: [
				{
				  selector: 'node',
				  style: {
					'label': 'data(id)' // on affiche l'id comme nom du noeud visuellement
				  }
				},
				{
					selector: 'node:selected',
					style: {
						'shape': 'hexagon',
					}
				},
				{
					selector : 'edge',
					style: {
						'curve-style': 'bezier', // bézier semble être le plus simple...
						'control-point-step-size': 30, // ça semble suffire en pixel pour que ça soit visible...
						'line-color' : chooseColorEdge, // fonction de spécification de couleur pour liens
					}
				},
				{
					selector: "edge[typeRoute='clientRoute']",
					style: {
						'width': 6,
					}
				},
				{
					selector: "node[type='desktop']",
					style: {
						width: 45,
						height: 45,
					}
				}
			]
		});
		
		// génération des assets du graph
		let dataTorNetwork = generateTorNetwork(clientsData, 5, 8, 12);
		console.log(dataTorNetwork);
		cret.add(dataTorNetwork[0]); // on ajoute les noeuds
		cret.add(dataTorNetwork[1]); // on ajoute les liens
		
		// création events cytoscape
		cret.on('tap', 'node', function(evt){ // TODO : ajouter un panel d'info sur noeud
			let node = evt.target;
			console.log(node); // juste du debug pour commencer
		});
		console.log(cret);
		
		// création layout
		let layout = cret.layout({ name: 'cose', // cose est quand même pas mal...
									animate: true, // TODO : l'animation est constante, mais la force n'est pas recalculé, trouvé un moyen pour que ça soit le cas
									animationDuration: 1000,
									//infinite: 'end', // OW SHI__
									nodeDimensionsIncludeLabels: true, // OUUUIIIIII
									randomize: false, // ça semble mettre les noeud dans leur ordre d'arrivée, ça me plait.
								});
		layout.run();
		
		return cret;
	}
	
	let cs = createCyto()

});